# This file was generated by liblab | https://liblab.com/

from .utils.json_map import JsonMap
from .base import BaseModel


@JsonMap({"code": "Code", "description": "Description"})
class DryIceWeightUnitOfMeasurement(BaseModel):
    """Container for Unit Of Measurement for Dry Ice.

    :param code: DryIce weight unit of measurement code. Valid values: - 00 - KG (Metric Unit of Measurements) or KGS - 01 - LB (English Unit of Measurements) or LBS
    :type code: str
    :param description: Text description of the code representing the unit of measure associated with the package.
    :type description: str
    """

    def __init__(self, code: str, description: str):
        self.code = code
        self.description = description
