# This file was generated by liblab | https://liblab.com/

from .utils.json_map import JsonMap
from .base import BaseModel


@JsonMap({"date_": "Date", "time": "Time"})
class EstimatedArrivalArrival(BaseModel):
    """Container for the Time-In-Transit arrival information by service. This is the most accurate delivery information available via the Rating API and will reflect changes in delivery schedules due to peak business seasons or holidays.

    :param date_: Scheduled Local Delivery Date. Format: YYYYMMDD
    :type date_: str
    :param time: The time UPS will pick up the shipment. This is commit Time. Military Time Format HHMMSS or HHMM, defaults to None
    :type time: str, optional
    """

    def __init__(self, date_: str, time: str = None):
        self.date_ = date_
        if time is not None:
            self.time = time
