# This file was generated by liblab | https://liblab.com/

from .utils.json_map import JsonMap
from .base import BaseModel


@JsonMap({"postal_code": "PostalCode", "country_code": "CountryCode"})
class FrsPaymentInformationAddress(BaseModel):
    """Payer Address Container.  Address container may be present for FRS Payment Information type = 02 and required when the FRS Payment Information type = 03.

    :param postal_code: Postal Code for UPS accounts billing address.  Postal Code  may be present when the FRS Payment Information type = 02 and type = 03., defaults to None
    :type postal_code: str, optional
    :param country_code: Country or Territory code for the  UPS accounts & billing address.  Country or Territory Code is required when the FRS Payment Information type = 02 and type= 03.
    :type country_code: str
    """

    def __init__(self, country_code: str, postal_code: str = None):
        if postal_code is not None:
            self.postal_code = postal_code
        self.country_code = country_code
