# This file was generated by liblab | https://liblab.com/

from .utils.json_map import JsonMap
from .base import BaseModel


@JsonMap({"code": "Code", "description": "Description"})
class PackagePackagingType(BaseModel):
    """Packaging Type Container.

    :param code: The code for the UPS packaging type associated with the package.  Valid values: - 00 - UNKNOWN - 01 - UPS Letter - 02 - Package - 03 - Tube - 04 - Pak - 21 - Express Box - 24 - 25KG Box - 25 - 10KG Box - 30 - Pallet - 2a - Small Express Box - 2b - Medium Express Box - 2c - Large Express Box. For FRS rating requests the only valid value is customer supplied packaging “02”.
    :type code: str
    :param description: A text description of the code for the UPS packaging type associated with the shipment.  Length is not validated., defaults to None
    :type description: str, optional
    """

    def __init__(self, code: str, description: str = None):
        self.code = code
        if description is not None:
            self.description = description
