# This file was generated by liblab | https://liblab.com/

from .utils.json_map import JsonMap
from .base import BaseModel


@JsonMap({"currency_code": "CurrencyCode", "monetary_value": "MonetaryValue"})
class PackageServiceOptionsShipperDeclaredValue(BaseModel):
    """Shipper Paid Declared Value Charge at Package level.   Valid for UPS World Wide Express Freight shipments.

    :param currency_code: The IATA currency code associated with the amount for the package.  UPS does not support all international currency codes. Refer to the appendix for a list of valid codes.
    :type currency_code: str
    :param monetary_value: The monetary value for the amount associated with the package.
    :type monetary_value: str
    """

    def __init__(self, currency_code: str, monetary_value: str):
        self.currency_code = currency_code
        self.monetary_value = monetary_value
