# This file was generated by liblab | https://liblab.com/

from .utils.json_map import JsonMap
from .base import BaseModel


@JsonMap({"code": "Code", "description": "Description"})
class RateRequestCustomerClassification(BaseModel):
    """Customer classification container. Valid if ShipFrom country or territory  is "US"

    :param code: Customer classification code.  Valid values:00 -  Rates Associated with Shipper Number01 -  Daily Rates04 -  Retail Rates05 - Regional Rates06 - General List Rates53 -  Standard List RatesLength is not validated.If customer classification code is not a valid value please refer to Rate Types Table on page 11.
    :type code: str
    :param description: Customer classification description of the code above.  Ignored if provided in the Request. Length is not validated., defaults to None
    :type description: str, optional
    """

    def __init__(self, code: str, description: str = None):
        self.code = code
        if description is not None:
            self.description = description
