# This file was generated by liblab | https://liblab.com/

from .utils.json_map import JsonMap
from .base import BaseModel


@JsonMap({"currency_code": "CurrencyCode", "monetary_value": "MonetaryValue"})
class RatedPackageBaseServiceCharge(BaseModel):
    """Base Service Charge Container.  These charges would be returned only when subversion is greater than or equal to 1701

    :param currency_code: The IATA currency code associated with the base service charge costs for the shipment.
    :type currency_code: str
    :param monetary_value: The base value of the specific service for the shipment. This is equal to transportation charges - fuel surcharges.
    :type monetary_value: str
    """

    def __init__(self, currency_code: str, monetary_value: str):
        self.currency_code = currency_code
        self.monetary_value = monetary_value
