# This file was generated by liblab | https://liblab.com/

from .utils.json_map import JsonMap
from .base import BaseModel


@JsonMap(
    {
        "lift_gate_at_delivery_indicator": "LiftGateAtDeliveryIndicator",
        "drop_off_at_ups_facility_indicator": "DropOffAtUPSFacilityIndicator",
    }
)
class ShipmentServiceOptionsDeliveryOptions(BaseModel):
    """Shipment Service Delivery Options Container.  Valid for UPS Worldwide Express Freight and UPS Worldwide Express Freight Midday shipments.

    :param lift_gate_at_delivery_indicator: The presence of the tag LiftGateAtDeliveryIndicator indicates that the shipment requires a lift gate for delivery., defaults to None
    :type lift_gate_at_delivery_indicator: str, optional
    :param drop_off_at_ups_facility_indicator: The presence of the tag DropOffAtUPSFacilityIndicator indicates the package will be dropped at a UPS facility for shipment., defaults to None
    :type drop_off_at_ups_facility_indicator: str, optional
    """

    def __init__(
        self,
        lift_gate_at_delivery_indicator: str = None,
        drop_off_at_ups_facility_indicator: str = None,
    ):
        if lift_gate_at_delivery_indicator is not None:
            self.lift_gate_at_delivery_indicator = lift_gate_at_delivery_indicator
        if drop_off_at_ups_facility_indicator is not None:
            self.drop_off_at_ups_facility_indicator = drop_off_at_ups_facility_indicator
