# This file was generated by liblab | https://liblab.com/

from .utils.json_map import JsonMap
from .base import BaseModel


@JsonMap(
    {
        "alcoholic_beverages_indicator": "AlcoholicBeveragesIndicator",
        "diagnostic_specimens_indicator": "DiagnosticSpecimensIndicator",
        "perishables_indicator": "PerishablesIndicator",
        "plants_indicator": "PlantsIndicator",
        "seeds_indicator": "SeedsIndicator",
        "special_exceptions_indicator": "SpecialExceptionsIndicator",
        "tobacco_indicator": "TobaccoIndicator",
        "e_cigarettes_indicator": "ECigarettesIndicator",
        "hemp_cbd_indicator": "HempCBDIndicator",
    }
)
class ShipmentServiceOptionsRestrictedArticles(BaseModel):
    """Restricted Articles container.  Valid for UPS World Wide Express Freight shipments.

    :param alcoholic_beverages_indicator: This field is a flag to indicate if the package has Alcohol. True if present; false otherwise.  Valid for UPS World Wide Express Freight shipments., defaults to None
    :type alcoholic_beverages_indicator: str, optional
    :param diagnostic_specimens_indicator: This field is a flag to indicate if the package has Biological substances. True if present; false otherwise.  Valid for UPS World Wide Express Freight shipments. Lane check will happen based on postal code/ city., defaults to None
    :type diagnostic_specimens_indicator: str, optional
    :param perishables_indicator: This field is a flag to indicate if the package has Perishables. True if present; false otherwise.  Valid for UPS World Wide Express Freight shipments., defaults to None
    :type perishables_indicator: str, optional
    :param plants_indicator: This field is a flag to indicate if the package has Plants. True if present; false otherwise.  Valid for UPS World Wide Express Freight shipments., defaults to None
    :type plants_indicator: str, optional
    :param seeds_indicator: This field is a flag to indicate if the package has Seeds. True if present; false otherwise.  Valid for UPS World Wide Express Freight shipments., defaults to None
    :type seeds_indicator: str, optional
    :param special_exceptions_indicator: This field is a flag to indicate if the package has Special Exceptions Restricted Materials. True if present; false otherwise.  Valid for UPS World Wide Express Freight shipments., defaults to None
    :type special_exceptions_indicator: str, optional
    :param tobacco_indicator: This field is a flag to indicate if the package has Tobacco. True if present; false otherwise.  Valid for UPS World Wide Express Freight shipments., defaults to None
    :type tobacco_indicator: str, optional
    :param e_cigarettes_indicator: This field is a flag to indicate if the package has E-Cigarettes. True if present; false otherwise.  Valid for UPS World Wide Express Freight shipments., defaults to None
    :type e_cigarettes_indicator: str, optional
    :param hemp_cbd_indicator: This field is a flag to indicate if the package has Hemp/CBD. True if present; false otherwise.  Valid for UPS World Wide Express Freight shipments., defaults to None
    :type hemp_cbd_indicator: str, optional
    """

    def __init__(
        self,
        alcoholic_beverages_indicator: str = None,
        diagnostic_specimens_indicator: str = None,
        perishables_indicator: str = None,
        plants_indicator: str = None,
        seeds_indicator: str = None,
        special_exceptions_indicator: str = None,
        tobacco_indicator: str = None,
        e_cigarettes_indicator: str = None,
        hemp_cbd_indicator: str = None,
    ):
        if alcoholic_beverages_indicator is not None:
            self.alcoholic_beverages_indicator = alcoholic_beverages_indicator
        if diagnostic_specimens_indicator is not None:
            self.diagnostic_specimens_indicator = diagnostic_specimens_indicator
        if perishables_indicator is not None:
            self.perishables_indicator = perishables_indicator
        if plants_indicator is not None:
            self.plants_indicator = plants_indicator
        if seeds_indicator is not None:
            self.seeds_indicator = seeds_indicator
        if special_exceptions_indicator is not None:
            self.special_exceptions_indicator = special_exceptions_indicator
        if tobacco_indicator is not None:
            self.tobacco_indicator = tobacco_indicator
        if e_cigarettes_indicator is not None:
            self.e_cigarettes_indicator = e_cigarettes_indicator
        if hemp_cbd_indicator is not None:
            self.hemp_cbd_indicator = hemp_cbd_indicator
